// RelativeLayers 0.9.7
// 
// $Id: rl_debug.js 1.7 04/02/02 21:22:32+01:00 gbevin@willow.uwyn.office $
// 
// Library for creating dynamic designs that adapt themselves to the user's
// browser environment.
// 
// Copyright (C) 1998-2004, Geert Bevin
// Distributed under the terms of the GNU Lesser General Public, v2.1 or later
// 
// gbevin[remove] at uwyn dot com
// http://www.uwyn.com/projects/relativelayers

var glb_debug_window;

function startDebug()
{
	var var_html = "<HTML>\n"
				   +"<HEAD>\n"
				   +"<TITLE>Debug window</TITLE>\n"
				   +"</HEAD>\n"
				   +"<BODY BGCOLOR='#CCCCCC'>\n"
				   +"<FORM><INPUT TYPE='BUTTON' VALUE='Close' ONCLICK='window.close()'></FORM>\n"
				   +"<B>DEBUG OUTPUT</B><BR><BR>\n"
				   +"</BODY>\n"
				   +"</HTML>";
	glb_debug_window = popupDialog("DEBUG_WINDOW", var_html);
};

function stopDebug()
{
	if (glb_debug_window)
	{
		glb_debug_window.close();
		glb_debug_window = null;
	}
};

function debug(par_debugentry)
{
	var var_today = new Date();

	glb_debug_window.document.write(var_today.getHours()+":"+var_today.getMinutes()+":"+var_today.getSeconds()+"."+var_today.getMilliseconds()+" : "+par_debugentry+"<BR>\n");
};

function showProperties(par_object)
{
	if (!par_object)
	{
		alert("showProperties() : Error, the object is null.");
	}
	else
	{
		var var_objectname;
		if (par_object.nodeName)
		{
			var_objectname = par_object.nodeName;
		}
		else if (par_object.getId)
		{
			var_objectname = par_object.getId();
		}
		else
		{
			var_objectname = "this";
		}

		var var_html =
		"<HTML>\n"
		+"<HEAD>\n"
		+"<TITLE>Property Viewer</TITLE>\n"
		+"</HEAD>\n"
		+"<BODY BGCOLOR='#CCCCCC'>\n"
		+"<FORM><INPUT TYPE='BUTTON' VALUE='Close' ONCLICK='window.close()''></FORM>\n"
		+"<H3> Properties of "+var_objectname+"</H3>\n"
		+"<TABLE BORDER='1' BGCOLOR='#EEEEEE' CELLPADDING='4' CELLSPACING='0'><TR BGCOLOR='#FFFFFF'><TH>Property</TH><TH>Type</TH><TH>Value</TH></TR>\n";

		for (var var_property in par_object)
		{
			if (var_property)
			{
				var var_propertytype = typeof(par_object[var_property]);
				var var_propertyvalue;

				if (!par_object[var_property])
				{
					var_propertyvalue = "null";
				}
				else if (var_propertytype.indexOf('string') != -1 &&
						 par_object[var_property] == "")
				{
					var_propertyvalue = "&nbsp;";
				}
				else if (var_propertytype.indexOf('object') != -1 ||
						 var_propertytype.indexOf('function') != -1 ||
						 var_propertytype.indexOf('HTML') != -1 ||
						 var_propertytype.indexOf('erText') != -1 ||
						 var_propertytype.indexOf('domain') != -1 ||
						 par_object[var_property].length > 30)
				{
					var_propertyvalue = "...";
				}
				else
				{
					var_propertyvalue = par_object[var_property];
				}

				var_html += "<TR><TD>"+var_objectname+"."+var_property+"</TD><TD ALIGN='CENTER'>"+var_propertytype+"</TD><TD ALIGN='RIGHT'>"+var_propertyvalue+"</TD></TR>\n";
			}
		}

		var_html += 
		"</TABLE><BR>"
		+"<FORM><INPUT TYPE='BUTTON' VALUE='Close' ONCLICK='window.close()'></FORM>\n"
		+"</BODY></HTML>\n";

		popupDialog("PROPERTY_VIEWER", var_html);

	}
	return false;
};

function popupDialog(par_id, par_html)
{
	var var_windowfeatures = "width=600,height=800,scrollbars=true,resizable=true";
	if (ie)
	{
		var_windowfeatures += ",left=0,top=0";
	}
	else
	{
		var_windowfeatures += ",screenX=0,screenY=0";
	}
	var var_window = window.open("", par_id, var_windowfeatures);
	var_window.document.open('text/html', true);
	var_window.document.write(par_html);
	var_window.document.close;

	return var_window;
};
