// RelativeLayers 0.9.7
// 
// $Id: rl_utility.js 1.7 04/02/02 21:22:32+01:00 gbevin@willow.uwyn.office $
// 
// Library for creating dynamic designs that adapt themselves to the user's
// browser environment.
// 
// Copyright (C) 1998-2004, Geert Bevin
// Distributed under the terms of the GNU Lesser General Public, v2.1 or later
// 
// gbevin[remove] at uwyn dot com
// http://www.uwyn.com/projects/relativelayers

// store the window dimensions for netscape windows versions that launch a resize event when the window is layouted the first time
var glb_previous_window_width = 0;
var glb_previous_window_height = 0;

// Internet explorer 4.0 doesn't implement these functions
if (!Array.prototype.push)
{
	Array.prototype.push = function(par_element)
	{
		this[this.length] = par_element;

		return this.length;
	};
}

if (!Array.prototype.pop)
{
	Array.prototype.pop = function()
	{
		var var_lastelement = null;

		if (this.length > 0)
		{
			var_lastelement = this[this.length-1];
			this.length = this.length-1;
		}

		return var_lastelement;
	};
}

// extensions to the Array class
Array.prototype.indexOf = function(par_object)
{
	var var_result = -1;
	var var_index;

	for (var_index = 0; var_index < this.length; var_index++)
	{
		if (this[var_index] == par_object)
		{
			var_result = var_index;
			break;
		}
	}

	return var_result;
};

Array.prototype.contains = function(par_object)
{
	var var_result = false;
	
	if (this.indexOf(par_object) != -1)
	{
		var_result = true;
	}

	return var_result;
};

Array.prototype.remove = function(par_object)
{
	var var_result = false;
	var var_index = this.indexOf(par_object);

	if (var_index > -1)
	{
		var var_index2;

		for (var_index2 = var_index+1; var_index2 < this.length; var_index2++)
		{
			this[var_index2-1] = this[var_index2];
		}
		this.pop();
		var_result = true;
	}

	return var_result;
};

String.prototype.chop = function()
{
	var var_choppedstring = "";

	if (this.length > 0)
	{
		var_choppedstring = this.substr(0, this.length - 1);
	}
	
	return var_choppedstring;
};

// new Hashtable class
function Hashtable()
{
	this.mbr_array = new Array();
};

Hashtable.prototype.clear = function()
{
	this.mbr_array.length = 0;
};

Hashtable.prototype.containsKey = function(par_key)
{
	var var_result = false;
	if (this.indexOfKey(par_key) != -1)
	{
		var_result = true;
	}

	return var_result;
};

Hashtable.prototype.containsValue = function(par_value)
{
	var var_result = false;
	if (this.indexOfValue(par_value) != -1)
	{
		var_result = true;
	}

	return var_result;
};

Hashtable.prototype.get = function(par_key)
{
	var var_result;
	var var_index = this.indexOfKey(par_key);

	if (var_index != -1)
	{
		var_result = this.mbr_array[var_index][1];
	}

	return var_result;
};

Hashtable.prototype.keys = function()
{
	var var_result = new Array();
	var var_index;

	for (var_index = 0; var_index < this.mbr_array.length; var_index++)
	{
		var_result.push(this.mbr_array[var_index][0]);
	}

	return var_result;
};

Hashtable.prototype.put = function(par_key, par_value)
{
	var var_index = this.indexOfKey(par_key);

	if (var_index == -1)
	{
		var_index = this.mbr_array.length;
	}

	this.mbr_array[var_index] = new Array();
	this.mbr_array[var_index][0] = par_key;
	this.mbr_array[var_index][1] = par_value;
};

Hashtable.prototype.remove = function(par_key)
{
	var var_succes = false;
	var var_index = this.indexOfKey(par_key);

	if (var_index != -1)
	{
		var var_index2;
		for (var_index2 = var_index+1; var_index2 < this.mbr_array.length; var_index2++)
		{
			this.mbr_array[var_index2-1] = this.mbr_array[var_index2];
		}
		this.mbr_array.pop();
		var_succes = true;
	}

	return var_succes;
};

Hashtable.prototype.size = function()
{
	return this.mbr_array.length;
};

Hashtable.prototype.values = function()
{
	var var_result = new Array();
	var var_index;

	for (var_index = 0; var_index < this.mbr_array.length; var_index++)
	{
		var_result.push(this.mbr_array[var_index][1]);
	}

	return var_result;
};

Hashtable.prototype.indexOfKey = function(par_key)
{
	var var_result = -1;
	var var_index;

	
	for (var_index = 0; var_index < this.mbr_array.length; var_index++)
	{
		if (this.mbr_array[var_index][0] == par_key)
		{
			var_result = var_index;
			break;
		}
	}

	return var_result;
};

Hashtable.prototype.indexOfValue = function(par_value)
{
	var var_result = -1;
	var var_index;

	for (var_index = 0; var_index < this.mbr_array.length; var_index++)
	{
		if (this.mbr_array[var_index][1] == par_value)
		{
			var_result = var_index;
			break;
		}
	}

	return var_result;
};

function getCSS(par_id)
{
	var var_css = null;

	if (op)
	{
		if (document.getElementById(par_id))
		{
			var_css = document.getElementById(par_id).style;
		}
	}
	else if (mz || kq)
	{
		if (document.getElementById(par_id))
		{
			var_css = document.getElementById(par_id).style;
		}
	}
	else if (ns)
	{
		var_css = getNSLayer(par_id);
	}
	else if (ie)
	{
		if (document.all[par_id])
		{
			var_css = document.all[par_id].style;
		}
	}

	return var_css;
};

// function to get the exact syntax to determine the layer (support for nested layers)
function getNSLayer(par_id, par_prefix)
{
	if (arguments.length < 2)
	{
		par_prefix = document.layers;
	}

	var var_foundlayer = 0;
	
	if (par_prefix.length > 0)
	{
		for (var var_layer = 0; var_layer < par_prefix.length; var_layer++)
		{
			if (par_prefix[var_layer].name == par_id)
			{
				var_foundlayer = par_prefix[var_layer];
	
				break;
			}
			if (par_prefix.length > 0)
			{
				var_foundlayer = getNSLayer(par_id, par_prefix[var_layer].layers);
				if (var_foundlayer)
				{
					break;
				}
			}
		}
	}
	
	return var_foundlayer;
};

function matchPercentage(par_string)
{
	if (par_string.charAt(par_string.length-1)=="%")
	{
		return 1;
	}
	else
	{
		return 0;
	}
};

function matchDigit(par_string)
{
	if (par_string.charCodeAt(0)>="0".charCodeAt(0) &&
		par_string.charCodeAt(0)<="9".charCodeAt(0))
	{
		return 1;
	}
	else
	{
		return 0;
	}
};

function matchFloat(par_string)
{
	var var_counter;
	for (var_counter = 0; var_counter < par_string.length; var_counter++)
	{
		if (0 == matchDigit(par_string.charAt(var_counter)) &&
			par_string.charAt(var_counter) != ".")
		{
			return 0;
		}
	}
	return 1;
};

function matchNumber(par_string)
{
	var var_counter;
	for (var_counter = 0; var_counter < par_string.length; var_counter++)
	{
		if (0 == matchDigit(par_string.charAt(var_counter)))
		{
			return 0;
		}
	}
	return 1;
};

function matchFirstCharDigit(par_string)
{
	return matchDigit(par_string.charAt(0));
};

function matchPercentagesAndNumbers(par_string)
{
	var var_matches = splitPlusMinus(par_string);
		
	return new Array(var_matches[0].substring(0, var_matches[0].length-1), var_matches[1]);
};

function splitRect(par_rect)
{
	return par_rect.split(/\(|px,?\s?\)?/);
};

function numericCompare(par_a, par_b)
{
	return par_a-par_b;
};

function splitPlusMinus(par_string)
{
	// ie4 and konqueror regexps are borked, so this is done manually
	// this just chops into parts according to the + and - operators
	// no real matching on numbers and percentage sign
	var var_matches = new Array();;
	var var_indices = new Array();
	var var_index = -1;

	// check if the string commences with a digit
	if (matchFirstCharDigit(par_string))
	{
		// it commences with a digit, so we prepend a +
		par_string = "+"+par_string;
	}

	while (1)
	{
		var_index = par_string.indexOf("+", var_index+1);
		if (var_index != -1)
		{
			var_indices.push(var_index);
		}
		else
		{
			break;
		}
	}
	var_index = -1;
	while (1)
	{
		var_index = par_string.indexOf("-", var_index+1);
		if (var_index != -1)
		{
			var_indices.push(var_index);
		}
		else
		{
			break;
		}
	}
	var_indices.sort(numericCompare);
	if (var_indices.length == 0)
	{
		var_matches.push(par_string);
	}
	else
	{
		var var_indexcounter = 0;
		var var_previousindex = 0;
		var var_substring;
		var_indices.push(par_string.length);
		while (var_indexcounter < var_indices.length)
		{
			if (var_indices[var_indexcounter] > 0)
			{
				var_substring = par_string.substring(var_previousindex, var_indices[var_indexcounter]);
				if (var_substring != "+" && var_substring != "-")
				{
					var_matches.push(var_substring);
				}
				var_previousindex = var_indices[var_indexcounter];
			}
			var_indexcounter++;
		}
	}
	
	return var_matches;
};

function concanatePercentagePixels(par_string)
{
	var var_newstring = "";
	var var_percentage = 0;
	var var_pixel = 0;
	var var_matches;
	var var_counter = 0;

	// check if the just digits without any operators nor percentages
	if (matchNumber(par_string))
	{
		// only digits
		var_newstring = "0%"+(parseInt(par_string)>=0?"+":"")+parseInt(par_string);
	}
	else
	{
		var_matches = splitPlusMinus(par_string);
		
		while (var_matches[var_counter])
		{
			if (var_matches[var_counter].charAt(var_matches[var_counter].length-1)=="%")
			{
				// get percentage
				var_percentage += (var_matches[var_counter].toString().chop())*1;
			}
			else
			{
				// get pixels
				var_pixel += (var_matches[var_counter])*1;
			}
			var_counter++;
		}
		
		var_newstring = var_percentage+"%"+(var_pixel>=0?"+":"")+var_pixel;
	}
	
	return var_newstring;
};

function extendMethod(par_functionname, par_functionsource, par_functionextension)
{
	var var_function = par_functionsource.toString();
	var var_function_declaration = "";
	var var_function_identifier_index = 0;
	var var_function_arguments = "";
	var var_function_source = "";
	
	if (var_function)
	{
		var_function_declaration = var_function.substring(0, var_function.indexOf("{"));
		var_function_identifier_index = var_function_declaration.indexOf("function");
		var_function_arguments = var_function_declaration.substring(var_function_declaration.indexOf("(", var_function_identifier_index)+1, var_function_declaration.lastIndexOf(")"));
		if (var_function_arguments.length > 0)
		{
			var_function_arguments = var_function_arguments.replace(/\s*,\s*/g, "\",\"");
			var_function_arguments = "\""+var_function_arguments+"\", ";
		}
		var_function_source = var_function.substring(var_function.indexOf("{")+1, var_function.lastIndexOf("}"));
		
		var var_function_source_body = "";
		var var_function_source_return = "";

		if (var_function_source.indexOf("return") == -1)
		{
			var_function_source_body = var_function_source;
		}
		else
		{
			var_function_source_body = var_function_source.substring(0, var_function_source.indexOf("return"));
			var_function_source_return = var_function_source.substr(var_function_source.indexOf("return"));
		}

		var var_extension = par_functionextension.toString();
		var var_extension_source;

		if (var_extension)
		{
			var_extension_source = var_extension.substring(var_extension.indexOf("{")+1, var_extension.lastIndexOf("}"));

			var var_function_extended = var_function_source_body+var_extension_source+var_function_source_return;
			eval("RelativeLayer.prototype."+par_functionname+" = new Function("+var_function_arguments+"var_function_extended)");
		}
	}
};
